module MineChain
using ..Ahorn, Maple

@mapdef Entity "Mine/JumpBar" JumpBar(x::Integer, y::Integer)

@mapdef Entity "Mine/VJumpBar" VJumpBar(x::Integer, y::Integer)


const placements = Ahorn.PlacementDict(
    "JumpBar (Mine)" => Ahorn.EntityPlacement(
       JumpBar
    ),"VJumpBar (Mine)" => Ahorn.EntityPlacement(
       VJumpBar
    )
)

edgeColor = (0, 0, 0, 255) ./ 255
centerColor = (100, 100, 100, 255) ./ 255

function Ahorn.selection(entity::JumpBar)
    x, y = Ahorn.position(entity)

    return Ahorn.Rectangle(x, y, 16, 3)
end
function Ahorn.selection(entity::VJumpBar)
    x, y = Ahorn.position(entity)

    return Ahorn.Rectangle(x, y, 3, 16)
end

function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::JumpBar)
    Ahorn.drawImage(ctx, "objects/JumpBar/JumpBar00", 0, 0)
end
function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::VJumpBar)  
    Ahorn.drawRectangle(ctx, 0, 0, 3, 16, centerColor, edgeColor)
end
end