module MineCutscene
using ..Ahorn, Maple

@mapdef Entity "Mine/CSTheMineEnter" CSTheMineEnter(x::Integer, y::Integer)
@mapdef Entity "Mine/CSTheMinePit" CSTheMinePit(x::Integer, y::Integer)
@mapdef Entity "Mine/CSTheMineDarkness" CSTheMineDarkness(x::Integer, y::Integer)


const placements = Ahorn.PlacementDict(
    "CSTheMineEnter (Mine)" => Ahorn.EntityPlacement(
       CSTheMineEnter,
        "rectangle"
    ),"CSTheMinePit (Mine)" => Ahorn.EntityPlacement(
       CSTheMinePit,
        "rectangle"
    ),"CSTheMineDarkness (Mine)" => Ahorn.EntityPlacement(
       CSTheMineDarkness,
        "rectangle"
    )
)

Ahorn.minimumSize(entity::CSTheMineEnter) = 8, 8
Ahorn.resizable(entity::CSTheMineEnter) = true, true
Ahorn.selection(entity::CSTheMineEnter) = Ahorn.getEntityRectangle(entity)


function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::CSTheMineEnter, room::Maple.Room)
    width = Int(get(entity.data, "width", 8))
    height = Int(get(entity.data, "height", 8))

    Ahorn.drawRectangle(ctx, 0, 0, width, height, (0.9, 0.9,0.9, 0.4), (1.0, 1.0, 1.0, 1.0))
end




Ahorn.minimumSize(entity::CSTheMinePit) = 8, 8
Ahorn.resizable(entity::CSTheMinePit) = true, true
Ahorn.selection(entity::CSTheMinePit) = Ahorn.getEntityRectangle(entity)


function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::CSTheMinePit, room::Maple.Room)
    width = Int(get(entity.data, "width", 8))
    height = Int(get(entity.data, "height", 8))

    Ahorn.drawRectangle(ctx, 0, 0, width, height, (0.9, 0.9,0.9, 0.4), (1.0, 1.0, 1.0, 1.0))
end

Ahorn.minimumSize(entity::CSTheMineDarkness) = 8, 8
Ahorn.resizable(entity::CSTheMineDarkness) = true, true
Ahorn.selection(entity::CSTheMineDarkness) = Ahorn.getEntityRectangle(entity)


function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::CSTheMineDarkness, room::Maple.Room)
    width = Int(get(entity.data, "width", 8))
    height = Int(get(entity.data, "height", 8))

    Ahorn.drawRectangle(ctx, 0, 0, width, height, (0.9, 0.9,0.9, 0.4), (1.0, 1.0, 1.0, 1.0))
end





end