module MineDashZone
using ..Ahorn, Maple

@mapdef Entity "Mine/DashZone" DashZone(x::Integer, y::Integer)


const placements = Ahorn.PlacementDict(
    "DashZone (Mine)" => Ahorn.EntityPlacement(
       DashZone,
        "rectangle"
    )
)

Ahorn.minimumSize(entity::DashZone) = 8, 8
Ahorn.resizable(entity::DashZone) = true, true
Ahorn.selection(entity::DashZone) = Ahorn.getEntityRectangle(entity)


function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::DashZone, room::Maple.Room)
    width = Int(get(entity.data, "width", 8))
    height = Int(get(entity.data, "height", 8))

    Ahorn.drawRectangle(ctx, 0, 0, width, height, (0.9, 0.9,0.9, 0.4), (1.0, 1.0, 1.0, 1.0))
end

end