module MineForcedDashZone
using ..Ahorn, Maple

@mapdef Entity "Mine/ForcedDashZoneUp" ForcedDashZoneUp(x::Integer, y::Integer)
@mapdef Entity "Mine/ForcedDashZoneDown" ForcedDashZoneDown(x::Integer, y::Integer)
@mapdef Entity "Mine/ForcedDashZoneRight" ForcedDashZoneRight(x::Integer, y::Integer)
@mapdef Entity "Mine/ForcedDashZoneLeft" ForcedDashZoneLeft(x::Integer, y::Integer)


const placements = Ahorn.PlacementDict(
    "ForcedDashZoneUp (Mine)" => Ahorn.EntityPlacement(
       ForcedDashZoneUp,
        "rectangle"
    ),
    "ForcedDashZoneDown (Mine)" => Ahorn.EntityPlacement(
       ForcedDashZoneDown,
        "rectangle"
    ),
    "ForcedDashZoneRight (Mine)" => Ahorn.EntityPlacement(
       ForcedDashZoneRight,
        "rectangle"
    ),
    "ForcedDashZoneLeft (Mine)" => Ahorn.EntityPlacement(
       ForcedDashZoneLeft,
        "rectangle"
    )
)

Ahorn.minimumSize(entity::ForcedDashZoneUp) = 8, 8

Ahorn.minimumSize(entity::ForcedDashZoneDown) = 8, 8

Ahorn.minimumSize(entity::ForcedDashZoneRight) = 8, 8

Ahorn.minimumSize(entity::ForcedDashZoneLeft) = 8, 8


Ahorn.resizable(entity::ForcedDashZoneUp) = true, true

Ahorn.resizable(entity::ForcedDashZoneDown) = true, true

Ahorn.resizable(entity::ForcedDashZoneRight) = true, true

Ahorn.resizable(entity::ForcedDashZoneLeft) = true, true


Ahorn.selection(entity::ForcedDashZoneUp) = Ahorn.getEntityRectangle(entity)
Ahorn.selection(entity::ForcedDashZoneDown) = Ahorn.getEntityRectangle(entity)
Ahorn.selection(entity::ForcedDashZoneRight) = Ahorn.getEntityRectangle(entity)
Ahorn.selection(entity::ForcedDashZoneLeft) = Ahorn.getEntityRectangle(entity)


function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::ForcedDashZoneUp, room::Maple.Room)
    width = Int(get(entity.data, "width", 8))
    height = Int(get(entity.data, "height", 8))

    Ahorn.drawRectangle(ctx, 0, 0, width, height, (1.0, 0.0,0.0,0.5))
end

function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::ForcedDashZoneDown, room::Maple.Room)
    width = Int(get(entity.data, "width", 8))
    height = Int(get(entity.data, "height", 8))

    Ahorn.drawRectangle(ctx, 0, 0, width, height, (1.0, 0.0,0.0,0.5))
end

function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::ForcedDashZoneRight, room::Maple.Room)
    width = Int(get(entity.data, "width", 8))
    height = Int(get(entity.data, "height", 8))

    Ahorn.drawRectangle(ctx, 0, 0, width, height, (1.0, 0.0,0.0,0.5))
end

function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::ForcedDashZoneLeft, room::Maple.Room)
    width = Int(get(entity.data, "width", 8))
    height = Int(get(entity.data, "height", 8))

    Ahorn.drawRectangle(ctx, 0, 0, width, height, (1.0, 0.0,0.0,0.5))
end

end