module MineLazerBeam
using ..Ahorn, Maple

@mapdef Entity "Mine/LazerBeamUp" LazerBeamUp(x::Integer, y::Integer)
@mapdef Entity "Mine/LazerBeamDown" LazerBeamDown(x::Integer, y::Integer)
@mapdef Entity "Mine/LazerBeamLeft" LazerBeamLeft(x::Integer, y::Integer)
@mapdef Entity "Mine/LazerBeamRight" LazerBeamRight(x::Integer, y::Integer)

const placements = Ahorn.PlacementDict(
   "LazerBeamUp (Mine)" => Ahorn.EntityPlacement(
      LazerBeamUp
   ),
   "LazerBeamDown (Mine)" => Ahorn.EntityPlacement(
      LazerBeamDown
   ),
   "LazerBeamLeft (Mine)" => Ahorn.EntityPlacement(
      LazerBeamLeft
   ),
   "LazerBeamRight (Mine)" => Ahorn.EntityPlacement(
      LazerBeamRight
   )
)



edgeColor = (108, 214, 235, 255) ./ 255
centerColor = (76, 168, 214, 102) ./ 255


function Ahorn.selection(entity::LazerBeamUp)
    x, y = Ahorn.position(entity)
    
    return Ahorn.Rectangle[Ahorn.Rectangle(x,y,16,16)]
end
function Ahorn.selection(entity::LazerBeamLeft)
    x, y = Ahorn.position(entity)
    
    return Ahorn.Rectangle[Ahorn.Rectangle(x,y,16,16)]
end
function Ahorn.selection(entity::LazerBeamDown)
    x, y = Ahorn.position(entity)
    
    return Ahorn.Rectangle[Ahorn.Rectangle(x,y,16,16)]
end
function Ahorn.selection(entity::LazerBeamRight)
    x, y = Ahorn.position(entity)
    
    return Ahorn.Rectangle[Ahorn.Rectangle(x,y,16,16)]
end

function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::LazerBeamUp)
    x = Int(get(entity.data, "x", 0))
    y = Int(get(entity.data, "y", 0))

    width = Int(get(entity.data, "width", 16))
    height = Int(get(entity.data, "height", 16))

    Ahorn.drawRectangle(ctx, 0, 0, width, height, centerColor, edgeColor)
end
function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::LazerBeamLeft)
    x = Int(get(entity.data, "x", 0))
    y = Int(get(entity.data, "y", 0))

    width = Int(get(entity.data, "width", 16))
    height = Int(get(entity.data, "height", 16))

    Ahorn.drawRectangle(ctx, 0, 0, width, height, centerColor, edgeColor)
end
function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::LazerBeamDown)
    x = Int(get(entity.data, "x", 0))
    y = Int(get(entity.data, "y", 0))

    width = Int(get(entity.data, "width", 16))
    height = Int(get(entity.data, "height", 16))

    Ahorn.drawRectangle(ctx, 0, 0, width, height, centerColor, edgeColor)
end
function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::LazerBeamRight)
    x = Int(get(entity.data, "x", 0))
    y = Int(get(entity.data, "y", 0))

    width = Int(get(entity.data, "width", 16))
    height = Int(get(entity.data, "height", 16))

    Ahorn.drawRectangle(ctx, 0, 0, width, height, centerColor, edgeColor)
end
end
