module MineMagicLight
using ..Ahorn, Maple

@mapdef Entity "Mine/MagicLight" MagicLight(x::Integer, y::Integer)

@pardef MoveMagicLight(x1::Integer, y1::Integer, x2::Integer=x1 + 16, y2::Integer=y1, width::Integer=16, height::Integer=16, spritePath::String="") = Entity( "Mine/MoveMagicLight", x=x1, y=y1, nodes=Tuple{Int, Int}[(x2, y2)], width=width, height=height, spritePath=spritePath)
const placements = Ahorn.PlacementDict(
   
	"MagicLight (Mine)" => Ahorn.EntityPlacement(
		MagicLight
	),
	"MovingMagicLight (Mine)" => Ahorn.EntityPlacement(
		MoveMagicLight,
        "rectangle",
        Dict{String, Any}(),
		 function(entity)
            entity.data["nodes"] = [(Int(entity.data["x"])  + 8, Int(entity.data["y"]))]
        end
	)
)


Ahorn.resizable(entity::MoveMagicLight) = false, false


function Ahorn.selection(entity::MagicLight)
    x, y = Ahorn.position(entity)

    return Ahorn.Rectangle(x, y, 16, 16)
end

Ahorn.nodeLimits(entity::MoveMagicLight) = 1, 1
function Ahorn.selection(entity::MoveMagicLight)
    nx, ny = Int.(entity.data["nodes"][1])
    x, y = Ahorn.position(entity)
    width = 8

    return [Ahorn.Rectangle(x, y, width, 8), Ahorn.Rectangle(nx - 8, ny - 8, 16, 16)]
end



function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::MagicLight, room::Maple.Room)
	texture = get(entity.data, "directory", "objects/MagicLight")
	realTexture = "$texture/MagicLight00.png"
    Ahorn.drawSprite(ctx, realTexture, 0, 0)
	# Ahorn.drawSprite(ctx, realTexture, 0, 0)
end

function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::MoveMagicLight, room::Maple.Room)
	texture = get(entity.data, "directory", "objects/MagicLight")
	realTexture = "$texture/magicLightMove00.png"
    Ahorn.drawSprite(ctx, realTexture, 0, 0)
	# Ahorn.drawSprite(ctx, realTexture, 0, 0)
end

end