module MineMineGlider
using ..Ahorn, Maple

@mapdef Entity "Mine/MineGlider" MineGlider(x::Integer, y::Integer, bubble::Bool=false, tutorial::Bool=false)


const placements = Ahorn.PlacementDict(
    "MineGlider (Mine)" => Ahorn.EntityPlacement(
       MineGlider
    ),
    "MineGlider (Floating) (Mine)" => Ahorn.EntityPlacement(
        MineGlider,
        "point",
        Dict{String, Any}(
            "bubble" => true
        )
    )
)


sprite = "objects/MineGlider/idle0"

function Ahorn.selection(entity::MineGlider)
    x, y = Ahorn.position(entity)

    return Ahorn.getSpriteRectangle(sprite, x, y)
end

function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::MineGlider)
    Ahorn.drawSprite(ctx, sprite, 0, 0)

    if get(entity, "bubble", false)
        curve = Ahorn.SimpleCurve((-7, -1), (7, -1), (0, -6))
        Ahorn.drawSimpleCurve(ctx, curve, (1.0, 1.0, 1.0, 1.0), thickness=1)
    end
end

end