﻿using Celeste;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Monocle;
using System;
using System.Collections;

using System.Collections.Generic;
using Celeste.Mod.Entities;

using On.Celeste;
using System.Linq;
using Celeste.Mod.Mine.Cutscene;
using FMOD;
using IL.Celeste;

using Microsoft.Xna.Framework.Graphics;

using Mono.Cecil.Pdb;
using System.Security.Cryptography;

namespace Celeste.Mod.Mine.Entities
{
    [Tracked(false)]
    [CustomEntity("Mine/DarkManager")]
    public class DarkManager : Entity
    {
        public float Strength = 1f;
        private static SpriteBank spriteBank;
        private Sprite sprite;
        private Image Darkener;
        private Coroutine CheckRoutine;
        private List<VertexLight> AllLight;
        private bool initialised = false;
        private VirtualTexture DrawElement;
        private bool isCollide = false;
        private SpriteBatch spBatch;
        private List<Color> fadeData;
        private List<Circle> circleList;
        public static ParticleType P_Dark;

        public static readonly BlendState AdditiveMaskToScreen = new BlendState
        {
            ColorSourceBlend = Blend.DestinationColor,
            ColorDestinationBlend = Blend.SourceAlpha,
            ColorBlendFunction = BlendFunction.ReverseSubtract,
            AlphaSourceBlend = Blend.Zero,
            AlphaDestinationBlend = Blend.One,
            AlphaBlendFunction = BlendFunction.Add
        };

        private Texture2D dtarget;
        public static MTexture gradient;

        public DarkManager(Vector2 position)

            : base(position)
        {
            spBatch = new SpriteBatch(Celeste.Graphics.GraphicsDevice);
            this.Collider = new Hitbox(1, 1);
            AllLight = new List<VertexLight>();
        }

        public DarkManager(EntityData e, Vector2 position)
            : this(e.Position + position)

        {
        }

        public override void Update()
        {
            Level l = Scene as Level;
            if (l.Entities.FindFirst<Player>() == null)
            {
                return;
            }
            if (initialised == false)
            {
                initialised = true;
                foreach (Entity item in l.Entities.FindAll<Entity>())
                {
                    if (item.Components.Get<VertexLight>() != null)
                    {
                        if (item != l.Entities.FindFirst<Player>() && item as Refill != item)
                        {
                            AllLight.Add(item.Components.Get<VertexLight>());
                        }
                    }
                }
            }
            isCollide = false;
            //Draw.SpriteBatch.Draw(Draw.Pixel.Texture.Texture, new Rectangle((int)this.Position.X, (int)this.Position.Y, 100, 100), Draw.Pixel.ClipRect, Color.White, 0, this.Position, SpriteEffects.None, 0f);
            l.ParticlesBG.Emit(P_Dark, 4, l.Camera.Position, new Vector2(Engine.Width, Engine.Height), (90f).ToRad());

            foreach (VertexLight item in AllLight)
            {
                Vector2 itemPosition = item.Entity.Position + item.Position;
                if (l.Entities.FindFirst<Player>().Collider.Collide(new Circle(item.EndRadius, itemPosition.X, itemPosition.Y)))
                {
                    isCollide = true;
                }

                //if (l.InsideCamera(itemPosition, 13))
                //{
                //    Vector2 position = item.Position + item.Entity.Position;
                //    Vector2 offset = new Vector2(-1f, 0);
                //    Vector2 particle = offset.Rotate(Calc.Random.Range(180f, 0f).ToRad()) * item.EndRadius * 1.3f + position;
                //    Rectangle rect = new Rectangle((int)particle.X, (int)particle.Y, 1, 1);
                //    bool collide = false;
                //    foreach (VertexLight itemtwo in AllLight)
                //    {
                //        Vector2 itemOfficialPosition = new Vector2(itemtwo.X + itemtwo.Entity.X, itemtwo.Y + itemtwo.Entity.Y);
                //        if (l.InsideCamera(itemOfficialPosition, item.EndRadius * 1.3f))
                //        {
                //            if (itemtwo != item && Vector2.Distance(itemOfficialPosition, particle) < item.EndRadius * 1.3f)
                //            {
                //                if (Collide.CircleToRect(itemOfficialPosition, itemtwo.EndRadius * 1.3f, rect))
                //                {
                //                    collide = true;
                //                }
                //            }
                //        }
                //    }
                //    if (!collide)
                //    {
                //        if (Calc.Random.Range(0, 100) < 50)
                //        {
                //            l.ParticlesFG.Emit(P_Dark, particle, 90f.ToRad());
                //        }
                //    }
                //}
            }
            if (isCollide == false)
            {
                l.Entities.FindFirst<Player>().Die(Vector2.Zero);
            }

            base.Update();
        }

        public override void Render()
        {
            if (initialised)
            {
                // Draw.Circle(item.Entity.Position + item.Position, it);
            }
            base.Render();
        }

        public void DrawDark(VirtualRenderTarget target)
        {
            VirtualRenderTarget result = GameplayBuffers.TempB;
            Engine.Instance.GraphicsDevice.SetRenderTarget(result);
            Engine.Instance.GraphicsDevice.Clear(Color.Transparent);
            Camera camera = (Scene as Level).Camera;
            Draw.SpriteBatch.Begin(SpriteSortMode.Deferred, BlendState.Additive, SamplerState.LinearClamp, DepthStencilState.None, RasterizerState.CullNone, null, camera.Matrix);
            float scaleMult = 1f / (float)gradient.Width;
            foreach (VertexLight item in AllLight)
            {
                if (item != null)
                {
                    //(item.Entity.Position + item.Position, item.EndRadius, Color.Red, 64);
                    gradient.DrawCentered(item.Entity.Position + item.Position, Color.Black, item.EndRadius * 3f * scaleMult);

                    //       gradient.Draw(item.Entity.Position + item.Position, new Vector2(0, 0), Color.Red, item.EndRadius / gradient.Width, 0);
                    //for (int i = 0; i < item.EndRadius; i++)
                    //{
                    //    Draw.Circle(item.Entity.Position + item.Position, i, Color.Red, i);
                    //}
                    // gradient.DrawCentered(item.Entity.Position + item.Position, Color.White, item.EndRadius);

                    // Draw.Rect(item.Position, item.StartRadius, Color.Red, 64);
                }
            }

            Draw.SpriteBatch.End();
            Engine.Instance.GraphicsDevice.SetRenderTarget(target);
            Draw.SpriteBatch.Begin(SpriteSortMode.Deferred, AdditiveMaskToScreen);
            Draw.SpriteBatch.Draw((RenderTarget2D)result, Vector2.Zero, Color.White);
            Draw.SpriteBatch.End();
        }

        public override void Added(Scene scene)
        {
            base.Added(scene);
        }

        public static void LoadContent()
        {
            gradient = GFX.Game["util/bloomgradient"];
        }
    }
}