﻿using Celeste;
using Microsoft.Xna.Framework;
using Monocle;
using System;
using System.Collections;

using System.Collections.Generic;
using Celeste.Mod.Entities;

using On.Celeste;
using System.Linq;
using Celeste.Mod.Mine.Cutscene;

namespace Celeste.Mod.Mine.Entities
{
    [Tracked(false)]
    public class CinematicTontonGravestone : BetterCutscene
    {
        public CinematicTontonGravestone(EntityData e, Vector2 position)
          : base(e, position, "CinematicTontonGravestone", false, true)

        {
        }

        public override IEnumerator Routine()
        {
            LockPlayer();

            yield return Textbox.Say("theMine_theTeacherGravestone");
            yield return 0.3f;
            // yield return Duck(1f);

            UnlockPlayer();
            EndCutscene(Level);
        }
    }

    [Tracked(false)]
    public class CinematicTontonGravestoneLater : BetterCutscene
    {
        public CinematicTontonGravestoneLater(EntityData e, Vector2 position)
          : base(e, position, "CinematicTontonGravestone", false, true)

        {
        }

        public override IEnumerator Routine()
        {
            LockPlayer();

            yield return Textbox.Say("theMine_theTeacherGravestoneLater");
            yield return 0.3f;
            // yield return Duck(1f);

            UnlockPlayer();
            EndCutscene(Level);
        }
    }

    [CustomEntity("Mine/TeacherGravestone")]
    public class TeacherGravestone : Entity
    {
        private static SpriteBank spriteBank;
        private Sprite sprite;
        private TalkComponent talkComponent;

        public void Action(Player p)
        {
            EntityData t = new EntityData();
            t.Width = 16;
            t.Height = 16;
            Level l = Scene as Level;
            if (l.Entities.FindFirst<HeartGem>() != null)
            {
                l.Add(new CinematicTontonGravestoneLater(t, this.Position));
            }
            else
            {
                l.Add(new CinematicTontonGravestone(t, this.Position));
            }
        }

        public TeacherGravestone(Vector2 position)
            : base(position)
        {
            this.Collider = new Hitbox(16, 16);
            talkComponent = new TalkComponent(new Rectangle(0, 0, 16, 16), new Vector2(8, -8), Action);
            this.Add(talkComponent);
        }

        public TeacherGravestone(EntityData e, Vector2 position)
            : this(e.Position + position)

        {
        }

        public override void Update()
        {
            Level l = Scene as Level;
            base.Update();
        }

        public override void Render()
        {
            if (this.CollideCheck<Player>())
            {
                sprite.DrawOutline(1);
            }
            base.Render();
        }

        public override void Added(Scene scene)
        {
            base.Added(scene);
            sprite = spriteBank.Create("TeacherGravestone");
            sprite.Play("idle");
            Add(sprite);
        }

        public static void LoadContent()
        {
            spriteBank = new SpriteBank(GFX.Game, "Graphics/Mine/Sprites.xml");
        }
    }
}