﻿using Celeste.Mod.Entities;
using Microsoft.Xna.Framework;
using Monocle;
using System;
using System.Collections.Generic;

namespace Celeste.Mod.Mine.Entities
{
    [Tracked(false)]
    [CustomEntity("Mine/Chain")]
    public class Chain : Entity
    {
        private static SpriteBank spriteBank;
        private Sprite sprite;

        public Chain(Vector2 position)
            : base(position)
        {
        }

        public Chain(EntityData e, Vector2 position)
            : this(e.Position + position)

        {
        }

        public override void Update()
        {
            base.Update();
        }

        public override void Render()
        {
            base.Render();
        }

        public override void Added(Scene scene)
        {
            base.Added(scene);
            sprite = spriteBank.Create("chain");
            sprite.Play("idle");
            sprite.SetOrigin(this.Width / 2, 0);
            Add(sprite);
        }

        public static void LoadContent()
        {
            spriteBank = new SpriteBank(GFX.Game, "Graphics/Mine/Sprites.xml");
        }
    }
}