﻿using Celeste;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Monocle;
using System;
using System.Collections;

using System.Collections.Generic;
using Celeste.Mod.Entities;

using On.Celeste;
using System.Linq;
using Celeste.Mod.Mine.Cutscene;
using FMOD;
using IL.Celeste;

using Microsoft.Xna.Framework.Graphics;

using Mono.Cecil.Pdb;
using System.Security.Cryptography;

namespace Celeste.Mod.Mine.Entities
{
    [Tracked(false)]
    [CustomEntity("Mine/FireManager")]
    public class FireManager : Entity
    {
        private static MTexture mist;
        private ParticleSystem backSystem;
        private static Parallax mist1;

        public FireManager(Vector2 position)
            : base(position)
        {
            backSystem = new ParticleSystem(-10000, 2048);
        }

        public FireManager(EntityData e, Vector2 position)
            : this(e.Position + position)

        {
        }

        private Color col;
        private bool shouldDraw = false;
        public static ParticleType P_Fire;

        public override void Update()
        {
            mist1.Update(Scene);
            Level l = Scene as Level;
            bool inCamera = l.IsInCamera(Position, 8f);
            int roomheight = l.Session.LevelData.Bounds.Height;
            int roomwidth = l.Session.LevelData.Bounds.Width;
            float Red = 100f;
            float d = ((float)l.Camera.Y - (float)l.Session.LevelData.Position.Y) / ((float)roomheight);

            backSystem.Emit(P_Fire, new Vector2(Calc.Random.Range(l.Camera.X - 100, l.Camera.X + Engine.Width + 100), l.Session.LevelData.Position.Y + roomheight + 8));
            backSystem.Emit(P_Fire, new Vector2(Calc.Random.Range(l.Camera.X - 100, l.Camera.X + Engine.Width + 100), l.Session.LevelData.Position.Y + roomheight + 8));
            backSystem.Emit(P_Fire, new Vector2(Calc.Random.Range(l.Camera.X - 100, l.Camera.X + Engine.Width + 100), l.Session.LevelData.Position.Y + roomheight + 8));
            // backSystem.Emit(P_Fire, new Vector2(Calc.Random.Range(l.Camera.X - 100, l.Camera.X +
            // Engine.Width + 100), l.Session.LevelData.Position.Y + roomheight + 8));

            if (roomheight > 100 * 8 && !l.Session.LevelData.Name.Contains("c"))
            {
                col = Color.DarkRed;
                col.A = (byte)(d * Red);
            }
            else
            {
                d = 1;
                col = Color.DarkRed; col.A = (byte)(Red);
            }

            mist1.Alpha = (100 + col.A / 255f);
            foreach (GCrystalStaticSpinner item in l.Entities.FindAll<GCrystalStaticSpinner>())
            {
                if (l.IsInCamera(item.Position, 8))
                {
                    item.fireMode = d;
                }
            }
            base.Update();
        }

        public static readonly BlendState AdditiveMaskToScreen = new BlendState
        {
            ColorSourceBlend = Blend.DestinationColor,
            ColorDestinationBlend = Blend.SourceColor,
            ColorBlendFunction = BlendFunction.Max,
            AlphaSourceBlend = Blend.SourceAlpha,
            AlphaDestinationBlend = Blend.DestinationAlpha,
            AlphaBlendFunction = BlendFunction.Add
        };

        public void DrawData(VirtualRenderTarget target)
        {
            VirtualRenderTarget result = GameplayBuffers.TempB;
            Engine.Instance.GraphicsDevice.SetRenderTarget(result);
            Engine.Instance.GraphicsDevice.Clear(Color.Transparent);
            Camera camera = (Scene as Level).Camera;
            Draw.SpriteBatch.Begin(SpriteSortMode.Deferred, BlendState.Additive, SamplerState.LinearClamp, DepthStencilState.None, RasterizerState.CullNone, null, camera.Matrix);

            Draw.Rect(camera.X, camera.Y, Engine.Width, Engine.Height, col);
            Draw.SpriteBatch.End();

            Engine.Instance.GraphicsDevice.SetRenderTarget(target);
            Draw.SpriteBatch.Begin(SpriteSortMode.Deferred, BlendState.AlphaBlend);
            Draw.SpriteBatch.Draw((RenderTarget2D)result, Vector2.Zero, Color.White);
            mist1.Render(Scene);
            Draw.SpriteBatch.End();
        }

        public override void Render()
        {
            base.Render();
        }

        public override void Added(Scene scene)
        {
            base.Added(scene);
            scene.Add(backSystem);
            Level l = Scene as Level;
            bool inCamera = l.IsInCamera(Position, 8f);
            int roomheight = l.Session.LevelData.Bounds.Height;
            int roomwidth = l.Session.LevelData.Bounds.Width;
            for (int i = 0; i < 300; i++)
            {
                if (Calc.Random.Range(0, 100) > 70)
                {
                    backSystem.Emit(P_Fire, new Vector2(Calc.Random.Range(0, roomwidth), roomheight + 8) + l.Session.LevelData.Position);
                }
                backSystem.Update();
            }
        }

        public override void Removed(Scene scene)
        {
            base.Removed(scene);
            backSystem.RemoveSelf();
        }

        public static void LoadContent()
        {
            mist1 = new Parallax(GFX.Misc["mist"]);
            mist1.LoopX = true;
            mist1.LoopY = true;
        }
    }
}