﻿using Celeste.Mod.Entities;
using Microsoft.Xna.Framework;
using Monocle;
using System;
using System.Collections.Generic;

namespace Celeste.Mod.Mine.Entities
{
    [Tracked(false)]
    [CustomEntity("Mine/Rail")]
    public class Rail : Entity
    {
        private static SpriteBank spriteBank;
        private Sprite sprite;

        public Rail(Vector2 position)
            : base(position)
        {
            this.Collider = new Hitbox(8, 1);
            this.Position.Y -= 1;
        }

        public Rail(EntityData e, Vector2 position)
            : this(e.Position + position)

        {
        }

        public override void Update()
        {
            base.Update();
        }

        public override void Render()
        {
            base.Render();
            Draw.Line(this.Position, this.Position + new Vector2(8, 0), Color.DarkGray);
        }

        public override void Added(Scene scene)
        {
            base.Added(scene);
        }

        public static void LoadContent()
        {
            spriteBank = new SpriteBank(GFX.Game, "Graphics/Mine/Sprites.xml");
        }
    }
}